<html>
<head>
 <title>Unsquished Asm in Hex Code</title>
</head>
<body>

<?php
// warn: PHP > 5.1.0 needed

if(version_compare(PHP_VERSION, "5.1.0", "<"))
  exit("<p>PHP > 5.1.0 needed. Sorry!</p>");

if ( ($_FILES["file"]["size"] < 30000) && (preg_match("/\.8xp/i",$_FILES["file"]["name"])) )
  {
  if ($_FILES["file"]["error"] > 0)
    {
    echo "<p>Some error occurred. Try again.</p>";
    }
  else
    {

$time_start = microtime(TRUE);

/* Unsquish starts */
// Get digits per row
$digitsrow = (int) trim(htmlspecialchars($_POST["hexdigits"]));
//$digitsrow = 0 + $_POST["hexdigits"];

// Use only temporary file
$asmfilename = $_FILES["file"]["tmp_name"];
$filesize = filesize($asmfilename);

// PHP 5.1.0 required for the optional arguments
$hexunsquished = file_get_contents($asmfilename,FILE_BINARY,NULL,76,$filesize-76-2);
/*
// PHP 4/5 compatible alternative. Not as optimized and with problems... Not tested.
$asmfilersc = fopen();
fseek($asmfilename, 76, SEEK_SET);
// fread() has a max of ~8000 bytes
$hexunsquished = fread($asmfilersc, $filesize-76-2);
*/

$hexsquished = strtoupper(bin2hex($hexunsquished));
//$array = unpack("H*",$hexunsquished);
//$hexsquished=strtoupper(implode($array));

$hexsquished = wordwrap($hexsquished, $digitsrow, "\n", TRUE);
//$array = str_split($hexsquished,$digitsrow);
//$hexsquished = strtoupper(implode("\n",$array));

 echo "<pre>:AsmPrgm".$hexsquished."\n</pre>";
/* End unsquish */
$time_end = microtime(TRUE);

// Delete temporary file
 unlink ( $asmfilename );
$time = $time_end - $time_start;
echo "<p>File unsquished in $time seconds.</p>";

    }
  }
else
  {
  echo "<p>Invalid file!</p>";
  }

/*
Simplethinker:
For anyone who wants to do this, here's the information on .8xp formats:
- First 74 (0x4A) bytes are the header, so they're junk for this
- Next two bytes are the "AsmPrgm" token (BB 6D), which should be skipped
- Actual program data
- Last two bytes are the header, so they're junk
Basically all that needs to be done is strip the first 76 and last two bytes of the .8xp file and you're left with the hex data.

DJ_Omnimaga:
and remember when showing the hex code to not forget the AsmPrgm token right on the first line
*/
?>

</body>
</html>