<html>
<head>
 <title>SPASM output</title>
</head>
<body>

<?php

// allowed extensions for assembly code: .asm, .z80, .inc
// other allowed extensions: .bmp, .bin
// max file size: 50 000 bytes
if ( ($_FILES["asmfsrc"]["size"] < 50000) && preg_match("/\.asm|\.z80|\.inc|\.bmp|\.bin/i",$_FILES["asmfsrc"]["name"]) )
  {
  if ($_FILES["asmfsrc"]["error"] > 0)
    {
    echo '<p>Some error on upload occurred. Try again.</p>';
    }
  else
    {

// Temporary folder to avoid conflicts
// next to current dir to be easy to pass to spasm
$current_dir = dirname(__FILE__);
$tmp_name = tempnam($current_dir, 'tmp');
unlink($tmp_name);
$tmp_dir_path  = $tmp_name.'f/';
$error[] = mkdir($tmp_dir_path);				// make the temp folder

// Upload files
$spasm_filename = "$tmp_dir_path/".$_FILES["asmfsrc"]["name"];
move_uploaded_file($_FILES["asmfsrc"]["tmp_name"], $spasm_filename);

if (count($_FILES)>15)
{
 echo '<p>15 files maximum!</p></body></html>';
 exit();
}
if (isset($_FILES["asmfsrcs"]))
{
foreach ($_FILES["asmfsrcs"]["error"] as $key => $error)
{
 if (($error == UPLOAD_ERR_OK) && ($_FILES["asmfsrcs"]["size"][$key] < 50000) && preg_match("/\.asm|\.z80|\.inc|\.bmp|\.bin/i", $_FILES["asmfsrcs"]["name"][$key]))
 {
 $tmp_name = $_FILES["asmfsrcs"]["tmp_name"][$key];
 $name = $_FILES["asmfsrcs"]["name"][$key];
 move_uploaded_file($tmp_name, "$tmp_dir_path/$name");
 } else if($error!=4) {
 echo '<p>Invalid extension or some error on upload occurred. Try again, sorry.</p></body></html>';
 exit();
 }
}
unset($tmp_name,$name);
}

// Server OS detection
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	$windows = TRUE;
} else {
	$linux = TRUE;
}

// Get options
// Miss some checks
$spasm_fileout = $_POST["asmfout"].$_POST["asmftype"];
//$spasm_filetype = $_POST["asmftype"];
$spasm_options = $_POST["spasm_opts"];

// switches: no colour output in console and include /inc/ folder
$cmd = escapeshellarg("spasm -N -I inc/ $spasm_options $spasm_filename $spasm_fileout");
if ($linux) $cmd .= './';

/* SPASM CALL */
$descriptorspec = array
(
0 => array("pipe", "r"),
1 => array("pipe", "w"), 
2 => array("pipe", "w")
);
$pipes = array();

$spasm_proc = proc_open($cmd, $descriptorspec, $pipes, $current_dir);

 if (is_resource($spasm_proc)) 
 {
 //timing out, 3 seconds (hard coded)
 $timed_out = FALSE;
 $time_start = time();
  do
  {
  if((time()-$time_start)>3)
    {
    $timed_out = TRUE;
    break;
    }
  $spasm_status = proc_get_status($spasm_proc);
  }
  while ($spasm_status['running']);

if ($timed_out)
{
//$ppid = $spasm_status['pid'];
//posix_kill($ppid, 9); //9 is the SIGKILL signal
 proc_terminate($spasm_proc, 9);
 echo "<pre>\r\nONLINE ASSEMBLER TIMED OUT</pre>\r\n";
}
else
{
$stdout = stream_get_contents($pipes[1]);
$stderr = stream_get_contents($pipes[2]);
$spasm_output = $stdout.$stderr;

 foreach ($pipes as $pipe)
     fclose($pipe);

// It is important to close any pipes before calling proc_close in order to avoid a deadlock
$return_value = proc_close($spasm_proc);
}

 } else {
  echo "<pre>\r\nOdd Error!?<pre>\r\n";
 }
/* END SPASM CALL */

if(!$timed_out)
{
// Print assembler output
 echo "<pre>Assembler Output:\r\n$spasm_output\r\n</pre>";

// Force file download later
echo '<p>All Temp files erased. Click bellow to download the file. The file is only deleted after downloading it!</p>';
echo '<p>Download: <a href="downloadasm.php?fileasm='.$spasm_fileout.'">'.$spasm_fileout.'</a>.</p>';

}

// Delete temporary folder and files
remove_dir($tmp_dir_path);
// rmdir ($tmp_dir_path);

    }
  }
  else
  {
  echo '<p>Invalid file(s)!</p>';
  }

      function remove_dir($current_dir) {
   
        if($dir = @opendir($current_dir)) {
            while (($f = readdir($dir)) !== false) {
                if($f > '0' and filetype($current_dir.$f) == "file") {
                    unlink($current_dir.$f);
                } elseif($f > '0' and filetype($current_dir.$f) == "dir") {
                    remove_dir($current_dir.$f."\\");
                }
            }
            closedir($dir);
            rmdir($current_dir);
        }
    }
/*
From SPASM Readme

Running SPASM 2
---------------

spasm [options] <input file> [output file]

The extension of the output file determines how
the program will be exported:

	.bin = Raw output
	.73P, .82P, .83P, .8XP, .85P, .86P = Programs for the TI-73, 83, 83+, 85, and 86
	.85S, .86S = Strings for the TI-85 and 86
	.8XK = Signed TI-83+ application

Options you can use are:

	Modes:

	-T = Generate a code listing, in a .lst file. This contains
	     each line of assembled code, along with its address,
	     hex value, and line number.
	-C = Counts code size and min/max execution time, and prints
	     the results on stderr. Macros and undefined names will
	     be ignored.
	-L = Creates a symbol table in a .lab file, with a list of
	     all the labels contained in the program and their values,
	     which can be used in another assembly program with #include.
	-S = Collects some basic statistics about the program
	     (number of input files, number of defines, code size,
	     data size, etc.) and prints them on stderr.

	Other options:

	-O = Don't create an output file. The output file argument can
	     be left out if this option is used.
	-I [directory] = Add an include directory. More than one of these
	                 can be used to use multiple include directories.
	-A = Treat label and macro names as case-sensitive.
	-D<name>[=value] = Create a define with a name of 'name' and
	                   optionally a value of 'value'.
	-N = Suppresses colors for output messages.
*/

?>

</body>
</html>