#include "fcreate.inc"

#macro do_mul(bit)
 #if mfstart = 1
   add hl,hl
 #endif
 #if num&bit = bit
   #if mfstart = 0
     #if num&(bit-1)>0
        transfer_reg
     #endif
     #define mfstart 1
   #else
     add_reg
   #endif
  #endif
#endmacro

#define muloop( loop ) #if loop > 0\ do_mul( 1<<(loop-1) )\ muloop( eval( loop-1) )\ #endif

#macro mul_hl_bc( num ) 
#define mfstart 0 
#define add_reg add hl,bc
#define transfer_reg  ld c,l \ ld b,h
 muloop(16) 
#if mfstart=0 \ ld hl,0 \ #endif 
#endmacro


#define sizeis(esize) #ifdef gsizeof esize #endif

#macro sizeof(name)
  #define gsizeof
  #define value eval(name)
  #undefine gsizeof
  value
#endmacro

#macro zdb(x) 
  #define gsize eval(gsize+1)
  #ifdef do_output
    .db x
  #endif
  #ifdef gin_entry
    #define arg_list concat(arg_list, x, ", ")
    #define value_list concat(value_list, x, ", ")
    #define prev_entry concat(prev_entry, "\n #define gsize eval(gsize + 1")
  #else
    1
  #endif
#endmacro

#macro zdw(x) 
  #define gsize eval(gsize+2)
  #ifdef do_output
    .dw x
  #endif
  #ifdef gin_entry
    #define arg_list concat(arg_list, x, ", ")
    #define value_list concat(value_list, x, "&$FF, ", x, ">>8&$FF, ")
    #define prev_entry concat(prev_entry, "\n #define gsize eval(gsize + 2")
  #else
    2
  #endif
#endmacro

#define db zdb(
#define dw zdw(

#macro start_entry(name)
  #define gsize 0
  #define gname eval(name)
  #define gname concat("\"", gname, "\"")
  #define arg_list concat("(")
  #define value_list .db 
  #define gin_entry
  #define prev_entry #define gsize 0
#endmacro

#macro end_entry()
  #define prev_entry concat(prev_entry, "\n gsize")
  #define arg_list concat("\"", arg_list, "terminator) \"")
  #define value_list concat("\"", value_list, "\"")
  #undefine gin_entry

  clr()
  wr("#macro ", gname, "_table_entry", arg_list)
  wr("  sizeis(", gsize , ")")
  wr(value_list)
  wr("#endmacro")
  run()

#endmacro

#macro start_table(name)
  #define gname concat("\"", name, "\"")
  .show gname
  clr()
  wr(gname,"_table:")
  wr("#macro zentry",arg_list)
  wr("  ",gname,"_table_entry",arg_list)
  wr("#endmacro")
  run()
#endmacro

#define entry zentry(
#define .entry zentry(

#macro end_table()
  
#endmacro

#macro get_entry(table)

  #define table_address concat(table, "_table")
  #define table_entry concat(table, "_table_entry")

  ld h,0\ ld l,a
  mul_hl_bc(sizeof(table_entry))

  ex de,hl
  ld hl,table_address
  add hl,de

#endmacro